# Project description
This project is based on the Tetris game invented by Alekseï Pajitnov in 1984.
The goal is to complete a maximum of lines in a grid with pieces (tetrominoes) that fall from the top.

# Building on Windows
This project works by compiling using Notepad++ for Raylib and including the following files to the gcc command :
```tetris-struct.c tetris-graph.c```

# How to play
## Rules
The goal is to complete the maximum number of lines without reaching the top of the grid.\
The score represents the number of lines completed.\
The game starts at level 1. Every 10 lines the level increases and the pieces fall faster.

## Commands
```LEFT``` and ```RIGHT``` move the current falling piece to the left or to the right.\
```DOWN``` accelerate the fall of the piece.\
```A``` and ```Z``` (or ```Q``` and ```W``` on QWERTY) rotate the piece anticlockwise or clockwise.

# Project contents
```lib``` contains the raylib library (Windows version, need to be changed if used on other OS).\
```src```contains all the raylib files.\
```tetris-graph.c``` contains all the functions necessary for the graphical interface of the game.\
```tetris-struct.c``` contains the implementation of the structure of the game.\
```tetris-main.c``` contains the game main loop.\
```tetris.data``` is read by the program to initialize the different tetrominoes.

# Improvements
## Features to add
- A title screen with a start button and an option to change the commands.
- A scoreboard stored in a file.
- A score that takes into account the tetrises completed by giving bonus points.
- A representation of the piece going next.
## Known issues
- The game can sometimes crash when spinning a piece at a specific time.
- It is possible to overlap the fixed pieces in the grid when spinning a piece too fast.